config/routes.rb
Rails.application.routes.draw do
  root to: 'pages#home'
  get 'ourwork' => 'pages#ourwork', as: :ourwork
  devise_for :users
  
  resources :gfs_registrations do
    collection do
      get :gfs_terms
    end
  end
  namespace :user do
    resources :messages do
      collection do
        get :get_messages
      end
    end
    resources :tests 
    resource :dashboard, controller: :dashboard
    resources :assignments do
      member do
        post :start
        get :started
        post :next
        get :complete
        get :completed
        get :show_reviewed_test
      end
      collection do
        get :reviewed
      end
    end
  end

  namespace :staff do
    resources :messages do
      collection do
        get :get_messages
        get :get_users
      end
    end
    resources :guest_users
    resource :dashboard, controller: :dashboard do 
      collection do
        get :pending_reviews
        get :completed_reviews
      end
    end
    resources :users do
      resources :assignments do
        member do
          get :review
          put :review_feedback
        end
      end
    end
    resources :questions do
      collection do
        get :upload_file
        post :upload
      end
    end
    resources :tests do
      member do
        get :upload_file
        post :upload
        get :print
      end
      resources :sections do
        member do
          get :questions
          put :questions_update
        end
      end
    end
  end

  namespace :guest_user do
    resources :tests, only: [:show] do
      member do
        get :new_register
        post :register
        post :start
        get :started
        post :next
        get :complete
        get :completed

      end
    end
  end
  
  resources :events do
    member do
      get :register
      get :registered_users
      get :details
      get :print_qr
      get :print_reg_users
    end
    collection do
      get ':category/listing' => 'events#listing', as: :listing
    end

    resources :feedbacks, :controller => "student_feedbacks"
    resources :registrations, :controller => "event_registrations"
  end


  get '/online/:slug' => 'user/tests#register', as: :online_test
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/event.rb
class Event < ApplicationRecord
  CATEGORIES = ['anthropreneur', 'job_seeker', 'general']
  FREQUENCIES = ['daily', 'weekly', 'monthly']
  DURATIONS = { 30 => '30 minutes', 40 => '40 minutes', 60 => '1 hour', 90 => '1.5 hours', 120 => '2 hours', 150 => '2.5 hours', 180 => '3 hours', 210 => '3.5 hours', 240 => '4 hours' }

  has_many :student_feedbacks
  has_many :user_events
  has_many :event_registrations

  scope :active, -> { where('event_date >= ?', Time.current.beginning_of_day) }
  scope :expired, -> { where('event_date < ?', Time.current.beginning_of_day) }

  validates :name, :event_date, :reg_end_date, :category,  presence: true

  def image_url
    image || "event_1.jpg"
  end

  def frequency_duration
    case frequency
    when 'daily'
      1.day
    when 'weekly'
      1.week
    when 'monthly'
      1.month
    end
  end
end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  before_action :authenticate_user!, only: [:register]

  def new
    @event = Event.new
  end

  def create
    @event = Event.new(event_params)
    upload_images
    if @event.save
      redirect_to event_path(@event)
    else
      render action: :new
    end
  end

  def index
    @events = Event.all.order(created_at: :desc)
  end

  def show
    @event = Event.find(params[:id])
    #@user_events = UserEvent.where(event_id: @event.id).joins(:user).where(users: {archived: false})
    #@user_events = @user_events.paginate(:page => params[:page], :per_page => 5)
    @event_registrations = EventRegistration.where(event_id: @event.id)
  end

  def print_qr
    @event = Event.find(params[:id])
    #@qr = RQRCode::QRCode.new( new_event_feedback_url(@event), :size => 10, :level => :h )
    #@qr = RQRCode::QRCode.new( "https://giga-business-plan.herokuapp.com/events/93/registrations/new", :size => 10, :level => :h )
    @qr = RQRCode::QRCode.new( "https://giga-business-plan.herokuapp.com/events/93/details", :size => 10, :level => :h )
    render layout: 'print'
  end

  def edit
    @event = Event.find(params[:id])
  end

  def update
    @event = Event.find(params[:id])
    upload_images
    if @event.update_attributes(event_params)
      flash[:success]="Successfully updated"
      redirect_to event_path(@event)
    else
      render 'edit'
    end
  end

  def destroy
    @event = Event.find(params[:id])
    @event.destroy
    redirect_to events_path
  end

  def register
    @event = Event.find(params[:id])
    @user_event = UserEvent.new
    @user_event.user_id = current_user.id
    @user_event.event_id = @event.id
    @user_event.save
    redirect_to details_event_path(@event)
    
  end

  def registered_users
    @event = Event.find(params[:id])
    #@user_events = UserEvent.where(event_id: @event.id).joins(:user).where(users: {archived: false})
    @event_registrations = EventRegistration.where(event_id: @event.id)
  end

  def print_reg_users
    @event = Event.find(params[:id])
    @event_registrations = EventRegistration.where(event_id: @event.id)
    render layout: 'print'

  end

  def details
    @event = Event.find(params[:id])
    #@user_events = UserEvent.where(event_id: @event.id).joins(:user).where(users: {archived: false})
    #@user_events = @user_events.paginate(:page => params[:page], :per_page => 5)
    @event_registrations = EventRegistration.where(event_id: @event.id)
    render layout: 'landing'
    
  end

  def listing
    @events = Event.where(category: [params[:category], 'general']).order(created_at: :desc)
    render layout: 'landing'
  end

  private
    def event_params
      params.require(:event).permit(:name, :description, :event_date, :reg_end_date, :category, :venue, :duration, :is_recurring, :frequency, :recurring_end_date, :map_embed_code, :speaker, :workshop_type)
    end
  
    def upload_images
      if params[:event][:image].present? and @event.valid?
        image = Cloudinary::Uploader.upload(params[:event][:image], options = {})
        @event.image = image["secure_url"]
      end
      if params[:event][:reg_image].present? and @event.valid?
        reg_image = Cloudinary::Uploader.upload(params[:event][:reg_image], options = {})
        @event.reg_image = reg_image["secure_url"]
      end
      if params[:event][:speaker_image].present? and @event.valid?
        speaker_image = Cloudinary::Uploader.upload(params[:event][:speaker_image], options = {})
        @event.speaker_image = speaker_image["secure_url"]
      end
    end
end

app/helpers/events_helper.rb
module EventsHelper
end

app/views/events/details.html.erb
<div class="outer_container">
  <div class="list_events">
    <div class="container" style="min-height: 500px; color: #333;">
      <div class="row">
        <div class="col">
          <div class= "row">
            <div class="col-lg-8" style="text-align: center;">
              <%= image_tag @event.image, style:"max-width:100%" %>
            </div>
            <% if @event.event_date >= Date.today %>
              <div class="col-lg-4" >
                <div class="event_details" style="margin-top: 10px;">
                  <%= @event.event_date.strftime("%b %d, %Y") %>
                </div>
                <div class="event_details">
                  <h3 class="section_title"><%= @event.name %></h3>
                </div>
                <small> <%= @event.workshop_type %></small><br />
                <br />
                  <div class="event_details" >
                    <div>
                    <% if @event.speaker_image.present? %>
                      <%= image_tag @event.speaker_image, style: "border-radius: 50%; width: 100px;" %>
                      <% end %>
                    </div>
                    
                    <div style="padding: 5px;">
                      <%= @event.speaker&.html_safe %>
                    </div>
                    
                    <div class="clear-height"></div>
                  </div>
                
              </div>
            <% else %>
              <div class="event_details">
                Event closed
              </div>
            <% end %>
          </div>

          <% if @event.event_date >= Date.today %>
          <div class="row">
            <div class="col-lg-8" >
            </div>
            <div class="col-lg-4" >
              <div class="col-lg-4_reg">
                <%# if !current_user || current_user.role != "staff" %>
                  <%# if current_user && UserEvent.where(user_id: current_user.id, event_id: @event.id).present? %>
                  <% if session[:event_id] == @event.id %>
                    <span class="registered">Registered</span>
                  <% else %>
                    <button class="event_details_btn">
                      <%#= link_to "Register", register_event_path(@event), style:"color: white;" %>
                      <%= link_to "Register", new_event_registration_path(@event), style:"color: white;" %>
                    </button>
                  <% end %>
                <%# end %>
              </div>
            </div>
          </div>
          <% end %>

          <hr />

          <div class="row">
            <div class="col-lg-8" >
            <% if @event.description.present? %>
              <h5 class="event_details_h5">
                Description
              </h5>
            <% end %>
              <div class="event_desc">
                <%= @event.description.html_safe %>
              </div>
             
            </div>
            <div class="col-lg-4">
              <div class="event_details">
                <h5 class="event_details_h5">Date and Time</h5> 
                <%= @event.event_date.strftime("%a, %b %d, %Y") %><br />
                <%= @event.event_date.strftime("%I:%M%P") %> to 
                <%= (@event.event_date + @event.duration.minutes).strftime("%I:%M%P") %>
              </div>
              <% if @event.venue.present? %>
                <div class="event_details">
                  <h5 class="event_details_h5">Location</h5> 
                  <%= @event.venue %>
                  <br />
                  <%= @event.map_embed_code&.html_safe %>
                  
                </div>
              <% end %>
            </div>
          </div>
          
          <%# if @user_events.present? %>
          <% if @event_registrations.present? %>
          <hr />

            <div class="row"> 
              <div class="col-lg-8 offset-lg-2">
                <div style="width: 100%"> 
                  <h5 class="event_details_h5 ">
                    (<%#= @user_events.count %><%= @event_registrations.count %>)Registered participants list
                  </h5>
                  <ul class="event_details">
                    <%# @user_events.each do |user_event| %>
                    <% @event_registrations.each do |reg_user| %>
                      <li>
                        <span> 
                          <%#= user_event.user.name.split(' ').collect{|s| s.first}.join("").upcase %> 
                          <%= reg_user.name.split(' ').collect{|s| s.first}.join("").upcase %> 
                        </span>
                        <div style="padding-left: 35px;">
                          <%#= user_event.user.name %><br />
                          <%#= user_event.user.school_college_institution %>
                          <%= reg_user.name %><br />
                          <%= reg_user.company %>
                        </div>
                      </li>
                    <% end %>
                  </ul>                
                </div>
              </div>
            </div>

          <% end %>

        </div>
      </div>
    </div>
  </div>
</div>

app/views/events/edit.html.erb
<%= form_for :event, url: event_path(@event), method: 'PUT' do |f| %>
<%= f.error_messages %>

    <div class="group">
      <%= f.label :"Cover Image :"%>
      <%= f.file_field :image %>
    </div>
 
    <div class="group">
      <%= f.label :"Registration Page Image "%>
      <%= f.file_field :reg_image %>
    </div>

    <div class="group">
      <%= f.label :"Trainer Image "%>
      <%= f.file_field :speaker_image %>
    </div>

 
    <div class="group">
      <%= f.label :"name "%>
      <%= f.text_field :name %>
    </div> 

    <div class="group">
      <%= f.label :"Workshop Type "%>
      <%= f.text_field :workshop_type %>
    </div> 

    <div class="group">
      <%= f.label :"description "%>
      <%= f.hidden_field :description, class: "trix-editor"%>
      <trix-editor input="event_description" placeholder="Description" style="min-height: 150px;"></trix-editor>
    </div>


    <div class="group">
      <%= f.label :"Event venue "%>
      <%= f.text_area :venue %>
    </div>

    <div class="group">
      <%= f.label :"Trainer Details "%>
      <%= f.text_area :speaker %>
    </div>

    <div class="group">
      <%= f.label :"Embed location code"%>
      <%= f.text_area :map_embed_code%>
    </div>

    <div class="group">
      <%= f.label :"event date:"%>
      <%= f.datetime_field :event_date%>
    </div>
    <div class="group">
      <%= f.label :"duration :" %>
      <%= f.select :duration, Event::DURATIONS.collect{|k,v| [v, k]}, {:prompt => '-- Select --'} %>
    </div>
   
    <div class="group">
      <%= f.label :"regestration end date :"%>
      <%= f.date_field :reg_end_date%>
    </div>

    <div class="group">
      <%= f.label :"category "%>
      <%= f.select(:category, Event::CATEGORIES, {:prompt => 'select'}) %>
    </div>

    <div class="group" style="text-align: center;">
      <%= f.submit "Update", class: "btn" %>
      <%= link_to 'Cancel', events_path, class: "btn" %>
    </div>
<% end %>

app/views/events/index.html.erb
<div>
  <%= link_to "Create Event", new_event_path, class: "btn", style: "float: right;" %> 
  <h4>Events List</h4>
</div>

<% if @events.present? %>
  <table class="striped">
    <tr>
      <th>Name</th>
      <th>Event Date</th>
      <th>Registration End Date</th>
      <th>Category</th>
      <th></th>
      <th></th>
    </tr>
    <tbody>
      <% @events.each do |event| %>
        <tr>
          <td><%= link_to event.name, event_path(event) %></td>
          <td><%= event.event_date.strftime("%d-%m-%Y") %></td>
          <td><%= event.reg_end_date.strftime("%d-%m-%Y") %></td>
          <td><%= event.category %></td>
          <td><%= link_to 'registered users', registered_users_event_path(event) %></td>
          <td><%= link_to event_path(event), method: :delete, data: { confirm: "You sure?"  } do %>
                                      Delete<% end %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
<% else %>
  <div style="text-align: center; background-color: #eee; padding-top: 15px;">
    Sorry you don't have any Events
    <br />
    <br />
  </div>
<% end %>

app/views/events/listing.html.erb
<div class="outer_container">
  <div class="list_events" >
    <div class="container">

      <% if @events.present? %>
        <div class="row">
          <div class="col">
            <div class="section_title_container text-center">
              <h2 class="section_title">Events</h2>
            </div>
          </div>
        </div>
        <div class="row events_row">
          <% @events.each do |event| %>
            <div class="col-lg-4 event_col">
              <div class="event event_left">
                <div class="event_image" >
                  <%= image_tag event.image_url %>
                </div>
                <div class="event_body d-flex flex-row align-items-start justify-content-start">
                  <div class="event_date">
                    <div class="d-flex flex-column align-items-center justify-content-center trans_200">
                      <div class="event_day trans_200">
                        <%= event.event_date.strftime("%d/%m") %>  
                      </div>
                    </div>
                  </div>
                  <div class="event_content">
                    <div class="event_title">
                      <h4><%= link_to event.name, details_event_path(event)%></h4>
                    </div>
                    <div class="event_info_container">
                      <div class="event_info">
                        <span>
                          <%= event.reg_end_date.strftime("%d/%m/%y") %> 
                        </span>
                      </div>
                      <div class="event_info">
                        <% if !current_user || current_user.role != "staff" %>
                          <% if current_user && UserEvent.where(user_id: current_user.id, event_id: event.id).present? %>
                            <span class="registered">
                              Registered
                            </span>
                          <% else %>
                            <% if event.reg_end_date >= Date.today %>
                              <%#= link_to "Register", register_event_path(event)   %>
                              <%= link_to "Register", new_event_registration_path(event)   %>
                            <% else %>
                              Registration closed
                            <% end %>
                          <% end %>
                        <% end %>
                      </div>
                      <div class="event_text">
                        <p><%= truncate(strip_tags(event.description), length: 250, seperator: ' ') %></p>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          <% end %>
        </div>
      <% else %>
        <div style="padding: 30px;">
          No events found
        </div>
      <% end %>

    </div>
  </div>
</div>

app/views/events/new.html.erb
<%= form_for :event, url: events_path do |f| %>
<%= f.error_messages %>

    <div class="group">
      <%= f.label :"Cover Image "%>
      <%= f.file_field :image %>
    </div>

    <div class="group">
      <%= f.label :"Registration Page Image "%>
      <%= f.file_field :reg_image %>
    </div>

    <div class="group">
      <%= f.label :"Trainer Image "%>
      <%= f.file_field :speaker_image %>
    </div>

 
    <div class="group">
      <%= f.label :"name "%>
      <%= f.text_field :name %>
    </div> 

    <div class="group">
      <%= f.label :"Workshop Type "%>
      <%= f.text_field :workshop_type %>
    </div> 

    <div class="group">
      <%= f.label :"description "%>
      <%= f.hidden_field :description, class: "trix-editor"%>
      <trix-editor input="event_description" placeholder="Description" style="min-height: 150px;"></trix-editor>
    </div>


    <div class="group">
      <%= f.label :"Event venue "%>
      <%= f.text_area :venue %>
    </div>

    <div class="group">
      <%= f.label :"Trainer "%>
      <%= f.text_area :speaker %>
    </div>

    <div class="group">
      <%= f.label :"Embed location code"%>
      <%= f.text_area :map_embed_code%>
    </div>

    <div class="group">
      <%= f.label :"event date"%>
      <%= f.datetime_field :event_date%>
    </div>


    <div class="group">
      <%= f.label :"duration " %>
      <%= f.select :duration, Event::DURATIONS.collect{|k,v| [v, k]}, {:prompt => '-- Select --'} %>
    </div>
   
    <div class="group">
      <%= f.label :"regestration end date "%>
      <%= f.date_field :reg_end_date%>
    </div>



    <div class="group">
        <%= f.label :"category "%>
        <%= f.select(:category, Event::CATEGORIES, {:prompt => 'select'}) %>
      </div>

    <div class="group" >
     <%= f.check_box :is_recurring, :id => "recurring", :onclick => "ShowHideDiv(this)" %> Recurring Event
    </div>

    <div class="group" id="dvfrequency" style="display: none">
      <%= f.label :"frequency "%>
      <%= f.select(:frequency, Event::FREQUENCIES, {:prompt => 'select'}) %>
    </div>

    <div class="group" id="dvrecurringdate" style="display: none">
      <%= f.label :"Recurring end date :"%>
      <%= f.date_field :recurring_end_date%>
    </div>

    <div class="group" style="text-align: center;">
      <%= f.submit "Submit", class: "btn" %>
      <%= link_to 'Cancel', events_path, class: "btn" %>
    </div>

 <% end %>

<script type="text/javascript">
  function ShowHideDiv(recurring) {
    var dvfrequency = document.getElementById("dvfrequency");
    dvfrequency.style.display = recurring.checked ? "block" : "none";
    var dvrecurringdate = document.getElementById("dvrecurringdate");
    dvrecurringdate.style.display = recurring.checked ? "block" : "none";
    }
</script>

app/views/events/print_qr.html.erb
<%= stylesheet_link_tag 'qr', media: 'all' %>
<div style="margin-top: 10px; margin-bottom: 10px; margin-left: 10px; margin-right: 10px; text-align: center;">
<%#= image_tag "Ta5-logo.png", style: "max-height: 48px;max-width: 200px;" %>

<br/>
</div>
<br /><br /><br />
<div class="qr">
  <%= raw @qr.as_html %>
</div>


<br /><br /><br />

<center>
<%#= new_event_feedback_url(@event) %>
</center>
<script type="text/javascript">print();</script>

app/views/events/print_reg_users.html.erb
<div style="padding-bottom: 20px; text-align: center;">
  <%= @event.name %>
</div>

<table border="1px">
    <tr>
      <th>Name</th>
      <th>Mobile-No</th>
      <th>Company</th>
      <th>Email</th>
      <th>Refer friend</th>
      <th>Looking For</th>
      <th>Regestered Date</th>
    </tr>
    <tbody>
      <%# @user_events.each do |user_event| %>
      <% @event_registrations.each do |reg_user| %>
        <tr>
          <%#= user_event.user.name %>
          <%#= user_event.user.email %>
          <%#= user_event.created_at.strftime("%d/%m/%Y") %>
          <td><%= reg_user.name %></td>
          <td><%= reg_user.mobile %></td>
          <td><%= reg_user.company %></td>
          <td><%= reg_user.email %></td>
          <td><%= reg_user.extra['refer_friend'] %></td>
          <td><%= reg_user.extra['looking_for'] %></td>
          <td><%= reg_user.created_at.strftime("%d/%m/%Y") %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
<script>
  print();
</script>

app/views/events/registered_users.html.erb
<div>
  <h4><% @event.name %></h4>
</div>

<%# if @user_events.present? %>
<span  style="float: right; margin-right: 10px; margin-top: 10px; "><%= link_to 'Print', print_reg_users_event_path(@event) %></span>
<% if @event_registrations.present? %>
  <table class="striped">
    <tr>
      <th>Name</th>
      <th>Mobile-No</th>
      <th>Company</th>
      <th>Email</th>
      <th>Refer friend</th>
      <th>Looking For</th>
      <th>Regestered Date</th>
    </tr>
    <tbody>
      <%# @user_events.each do |user_event| %>
      <% @event_registrations.each do |reg_user| %>
        <tr>
          <%#= user_event.user.name %>
          <%#= user_event.user.email %>
          <%#= user_event.created_at.strftime("%d/%m/%Y") %>
          <td><%= reg_user.name %></td>
          <td><%= reg_user.mobile %></td>
          <td><%= reg_user.company %></td>
          <td><%= reg_user.email %></td>
          <td><%= reg_user.extra['refer_friend'] %></td>
          <td><%= reg_user.extra['looking_for'] %></td>
          <td><%= reg_user.created_at.strftime("%d/%m/%Y") %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <% else %>
  <div style="text-align: center; background-color: #eee; padding-top: 15px;">
    Sorry you don't have any users for this event
    <br />
    <br />
  </div>
<% end %>

app/views/events/show.html.erb
<div class="container" style="min-height: 500px; ">
  <div>

    <div class="event_img">
      <%= image_tag @event.image_url, style:"max-width:100%"%>
    </div>
    <% if @event.event_date >= Date.today %>
      <div class="event_date_name">
        <div class="event_show">
          <%= @event.event_date.strftime("%a, %b %d, %Y") %>
        </div>
        <div class="event_show">
          <h3 class="section_title"><%= @event.name %></h3>
        </div>
        <div class="event_show">
        <small> <%= @event.workshop_type %></small><br />
        </div>
                <br />
                  <div class="event_show" >
                    <div>
                    <% if @event.speaker_image.present? %>
                      <%= image_tag @event.speaker_image, style: "border-radius: 50%; width: 100px;" %>
                      <% end %>
                    </div>
                    
                    <div style="padding: 5px;">
                      <%= @event.speaker&.html_safe %>
                    </div>
                    
                    <div class="clear-height"></div>
                  </div>
     

        <div class="event_show">
           <%= link_to 'Print QR Code', print_qr_event_path(@event) %>
        </div>
        <div class="event_show">
           <%= link_to 'Registration link', new_event_registration_path(@event) %>
        </div>

      </div>
    <% else %>
      <div class="event_closed" >
        Event closed
      </div>
    <% end %>
    
    <div class="clear-height"></div>

  </div>

  <hr />
 
  <div>
    <div class="lbl_desc" >
      <% if @event.description.present? %>
      <h5 class="event_show_h5">
        Description
      </h5>
      <% end %>
      <div class="event_desc">
        <%= @event.description.html_safe %>
      </div>
    </div>
    <div class="event_date_location">
      <div class="event_date_time">
        <h5 class="event_show_h5">Date and Time</h5> 
        <%= @event.event_date.strftime("%a, %b %d, %Y") %><br />
        <%= @event.event_date.strftime("%I:%M%P") %> to 
        <%= (@event.event_date + @event.duration.minutes).strftime("%I:%M%P") %>
      </div>
      <% if @event.venue.present? %>
        <div class="event_show">
          <h5 class="event_show_h5">Location</h5> 
          <%= @event.venue %>
        </div>
      <% end %>
    </div>
    <div class="clear-height"></div>
  </div>
  
  <%# if @user_events.present? %>
  <% if @event_registrations.present? %>
    <hr />

    <div class="user_div"> 
      <h5 class="event_show_h5">Registered participants list</h5>
      <ul>
        <%# @user_events.each do |user_event| %>
        <% @event_registrations.each do |reg_user| %>
          <li style="width: 50%; float: left; padding: 5px;">
            <span> 
              <%#= user_event.user.name.split(' ').collect{|s| s.first}.join("").upcase %> 
              <%= reg_user.name.split(' ').collect{|s| s.first}.join("").upcase %>
            </span>
            <div class="user_div_name">
              <%#= user_event.user.name %><br />
              <%#= user_event.user.school_college_institution %>
              <%= reg_user.name %><br />
                          <%= reg_user.company %>
            </div>
          </li>
        <% end %>
        <li class="clear-height"></li>
      </ul>                
    </div>
      
    
  <% end %>
</div>

<div class="event_show_edit">
  <%= link_to 'Edit', edit_event_path, class: "btn", style:"width: 20%;" %>
</div>